#pragma once

#include "preferences.h"
#include "types.h"

// CPPgAdvanced dialog

class CPPgAdvanced : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgAdvanced)

public:
	CPPgAdvanced();
	virtual ~CPPgAdvanced();
	void SetPrefs(CPreferences* in_prefs) {	app_prefs = in_prefs; }
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();

// Dialog Data
	enum { IDD = IDD_PPG_ADVANCED };

protected:
	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}

	CPreferences *app_prefs;
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
private:
	void LoadSettings(void);
public:
	afx_msg void OnEnChangeMinClients()			{SetModified();}
	afx_msg void OnEnChangeMaxClients()			{SetModified();}
	afx_msg void OnEnChangeDataRate()			{SetModified();}
	afx_msg void OnEnChangeBanTimes()			{SetModified();}
	afx_msg void OnEnChangeMinReqTime()			{SetModified();}
	afx_msg void OnEnChangeBanTime()			{SetModified();}
	afx_msg void OnBnClickedComEnabled();
	afx_msg void OnEnChangeComString()			{SetModified();}
	afx_msg void OnBnClickedNoBanEnabled()		{SetModified();}
	afx_msg void OnEnChangeRestoreTime()		{SetModified();}
	afx_msg void OnEnChangeLoadQuantities()		{SetModified();}
	afx_msg void OnEnChangeOutdated()			{SetModified();}
	afx_msg void OnEnChangeMaxSourcesFile()		{SetModified();}
	afx_msg void OnBnClickedSLSEnabled();
	afx_msg void OnBnClickedmlDonkeyCM() 		{SetModified();};
	void Localize(void);
};	
