// PPgSorting.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgSorting.h"
#include "ArrowCombo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// PPgSorting dialog

IMPLEMENT_DYNAMIC(CPPgSorting, CPropertyPage)
CPPgSorting::CPPgSorting()
	: CPropertyPage(CPPgSorting::IDD)
{
}

CPPgSorting::~CPPgSorting()
{
}

void CPPgSorting::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SORT_SERVERS, m_serverCols);
	DDX_Control(pDX, IDC_SORT_FILES, m_fileCols);
	DDX_Control(pDX, IDC_SORT_DOWNLOADS, m_downloadCols);
	DDX_Control(pDX, IDC_SORT_UPLOADS, m_uploadCols);
	DDX_Control(pDX, IDC_SORT_QUEUE, m_queueCols);
	DDX_Control(pDX, IDC_SORT_SEARCH, m_searchCols);
	DDX_Control(pDX, IDC_SORT_IRC, m_ircCols);
	DDX_Control(pDX, IDC_SORT_SOURCES1, m_sourceCols1);
	DDX_Control(pDX, IDC_SORT_SOURCES2, m_sourceCols2);
}

BEGIN_MESSAGE_MAP(CPPgSorting, CPropertyPage)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SORT_USEIT, OnBnClickedUseSort)
	ON_CBN_SELCHANGE(IDC_SORT_SERVERS, OnCbnSelchangeSortServers)
	ON_CBN_SELCHANGE(IDC_SORT_FILES, OnCbnSelchangeSortFiles)
	ON_CBN_SELCHANGE(IDC_SORT_DOWNLOADS, OnCbnSelchangeSortDownloads)
	ON_CBN_SELCHANGE(IDC_SORT_SOURCES1, OnCbnSelchangeSortSources1)
	ON_CBN_SELCHANGE(IDC_SORT_SOURCES2, OnCbnSelchangeSortSources2)
	ON_CBN_SELCHANGE(IDC_SORT_UPLOADS, OnCbnSelchangeSortUploads)
	ON_CBN_SELCHANGE(IDC_SORT_QUEUE, OnCbnSelchangeSortQueue)
	ON_CBN_SELCHANGE(IDC_SORT_SEARCH, OnCbnSelchangeSortSearch)
	ON_CBN_SELCHANGE(IDC_SORT_IRC, OnCbnSelchangeSortIrc)
	ON_BN_CLICKED(IDC_SORT_SOURCES2_BOX, OnBnClickedSortSources2Box)
	ON_BN_CLICKED(IDC_UPDATEQUEUE, OnBnClickedUpdateQueueList)
END_MESSAGE_MAP()

BOOL CPPgSorting::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	return TRUE;
}

void CPPgSorting::LoadSettings(void)
{
	CheckDlgButton(IDC_SORT_USEIT,(app_prefs->DoUseSort())?1:0);
	CheckDlgButton(IDC_SORT_SOURCES2_BOX,(app_prefs->DoUseSrcSortCol2())?1:0);
	GetDlgItem(IDC_SORT_SOURCES2)->EnableWindow(IsDlgButtonChecked(IDC_SORT_SOURCES2_BOX));
	int i;
	m_serverCols.SetCurSel(0);
	for(i = 0; i != m_serverCols.GetCount(); i++)
		if(m_serverCols.GetItemData(i) == app_prefs->GetServerSortCol())
			m_serverCols.SetCurSel(i);
	m_fileCols.SetCurSel(0);
	for(i = 0; i != m_fileCols.GetCount(); i++)
		if(m_fileCols.GetItemData(i) == app_prefs->GetFileSortCol())
			m_fileCols.SetCurSel(i);
	m_downloadCols.SetCurSel(0);
	m_previousDownCol=app_prefs->GetDownloadSortCol();
	for(i = 0; i != m_downloadCols.GetCount(); i++)
		if(m_downloadCols.GetItemData(i) == m_previousDownCol)
			m_downloadCols.SetCurSel(i);
	m_uploadCols.SetCurSel(0);
	for(i = 0; i != m_uploadCols.GetCount(); i++)
		if(m_uploadCols.GetItemData(i) == app_prefs->GetUploadSortCol())
			m_uploadCols.SetCurSel(i);
	m_queueCols.SetCurSel(0);
	for(i = 0; i != m_queueCols.GetCount(); i++)
		if(m_queueCols.GetItemData(i) == app_prefs->GetQueueSortCol())
			m_queueCols.SetCurSel(i);
	m_searchCols.SetCurSel(0);
	for(i = 0; i != m_searchCols.GetCount(); i++)
		if(m_searchCols.GetItemData(i) == app_prefs->GetSearchSortCol())
			m_searchCols.SetCurSel(i);
	m_ircCols.SetCurSel(0);
	for(i = 0; i != m_ircCols.GetCount(); i++)
		if(m_ircCols.GetItemData(i) == app_prefs->GetIrcSortCol())
			m_ircCols.SetCurSel(i);
	m_sourceCols1.SetCurSel(0);
	for(i = 0; i != m_sourceCols1.GetCount(); i++)
		if(m_sourceCols1.GetItemData(i) == app_prefs->GetSrcSortCol1())
			m_sourceCols1.SetCurSel(i);
	m_sourceCols2.SetCurSel(0);
	for(i = 0; i != m_sourceCols2.GetCount(); i++)
		if(m_sourceCols2.GetItemData(i) == app_prefs->GetSrcSortCol2())
			m_sourceCols2.SetCurSel(i);

	if(app_prefs->GetUpdateQueueList())
		CheckDlgButton(IDC_UPDATEQUEUE,1);
	else
		CheckDlgButton(IDC_UPDATEQUEUE,0);

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgSorting::OnApply()
{	
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		app_prefs->SetUseSort(IsDlgButtonChecked(IDC_SORT_USEIT));
		app_prefs->SetUseSrcSortCol2(IsDlgButtonChecked(IDC_SORT_SOURCES2_BOX));
		app_prefs->SetServerSortCol((int8)m_serverCols.GetItemData(m_serverCols.GetCurSel()));
		app_prefs->SetUploadSortCol((int8)m_uploadCols.GetItemData(m_uploadCols.GetCurSel()));
		app_prefs->SetQueueSortCol((int8)m_queueCols.GetItemData(m_queueCols.GetCurSel()));
		app_prefs->SetSearchSortCol((int8)m_searchCols.GetItemData(m_searchCols.GetCurSel()));
		app_prefs->SetIrcSortCol((int8)m_ircCols.GetItemData(m_ircCols.GetCurSel()));
		app_prefs->SetFileSortCol((uint16)m_fileCols.GetItemData(m_fileCols.GetCurSel()));
		app_prefs->SetDownloadSortCol((int8)m_downloadCols.GetItemData(m_downloadCols.GetCurSel()));
		app_prefs->SetSrcSortCol1((int8)m_sourceCols1.GetItemData(m_sourceCols1.GetCurSel()));
		app_prefs->SetSrcSortCol2((int8)m_sourceCols2.GetItemData(m_sourceCols2.GetCurSel()));

		app_prefs->SetUpdateQueueList(IsDlgButtonChecked(IDC_UPDATEQUEUE));

		SetModified();

		theApp.emuledlg->serverwnd.serverlistctrl.SortInit(app_prefs->GetServerSortCol());
		theApp.emuledlg->transferwnd.uploadlistctrl.SortInit(app_prefs->GetUploadSortCol());
		theApp.emuledlg->transferwnd.queuelistctrl.SortInit(app_prefs->GetQueueSortCol());
		theApp.emuledlg->searchwnd.searchlistctrl.SortInit(app_prefs->GetSearchSortCol());
		theApp.emuledlg->ircwnd.SortInit(app_prefs->GetIrcSortCol());
		theApp.emuledlg->sharedfileswnd.sharedfilesctrl.SortInit(app_prefs->GetFileSortCol());
		SetModified(FALSE);//needs the settings for downloadlistcontrol
		theApp.emuledlg->transferwnd.downloadlistctrl.SortInit(99);//major override...
		theApp.emuledlg->transferwnd.downloadlistctrl.SortInit(true);//normal override, in case we show sources...
	}

	return CPropertyPage::OnApply();
}

void CPPgSorting::Localize(void)
{
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_SORTING));
		GetDlgItem(IDC_SORT_USEIT)->SetWindowText(GetResString(IDS_SORT_USEIT));
		GetDlgItem(IDC_SORT_SERVERS_LBL)->SetWindowText(GetResString(IDS_SORT_SERVERS_LBL));
		GetDlgItem(IDC_SORT_DOWNLOADS_LBL)->SetWindowText(GetResString(IDS_SORT_DOWNLOADS_LBL));
		GetDlgItem(IDC_SORT_UPLOADS_LBL)->SetWindowText(GetResString(IDS_SORT_UPLOADS_LBL));
		GetDlgItem(IDC_SORT_QUEUE_LBL)->SetWindowText(GetResString(IDS_SORT_QUEUE_LBL));
		GetDlgItem(IDC_SORT_SEARCH_LBL)->SetWindowText(GetResString(IDS_SORT_SEARCH_LBL));
		GetDlgItem(IDC_SORT_IRC_LBL)->SetWindowText(GetResString(IDS_SORT_IRC_LBL));
		GetDlgItem(IDC_SORT_GRP)->SetWindowText(GetResString(IDS_SORT_GRP));
		GetDlgItem(IDC_SORT_SOURCES1_LBL)->SetWindowText(GetResString(IDS_SORT_SOURCES1_LBL));
		GetDlgItem(IDC_SORT_SOURCES2_BOX)->SetWindowText(GetResString(IDS_SORT_SOURCES2_LBL));
		GetDlgItem(IDC_SORT_FILES_LBL)->SetWindowText(GetResString(IDS_SORT_FILES_LBL));

		GetDlgItem(IDC_UPDATEQUEUE)->SetWindowText(GetResString(IDS_UPDATEQUEUE));

		m_serverCols.ResetContent();
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_SL_SERVERNAME)+"[^]"),0);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_SL_SERVERNAME)),10);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_IP)+"[^]"),1);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_IP)),11);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_DESCRIPTION)+"[^]"),2);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_DESCRIPTION)),12);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_PING)+"[^]"),3);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_PING)),13);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_UUSERS)+"[^]"),4);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_UUSERS)),14);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_UUSERS)+"[^^]"),9);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_UUSERS)+"[vv]"),19);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_PW_FILES)+"[^]"),5);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_PW_FILES)),15);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_PREFERENCE)+"[^]"),6);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_PREFERENCE)),16);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_UFAILED)+"[^]"),7);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_UFAILED)),17);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_STATICSERVER)+"[^]"),8);
		m_serverCols.SetItemData(m_serverCols.AddString(GetResString(IDS_STATICSERVER)),18);

		m_fileCols.ResetContent();
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_DL_FILENAME)+"[^]"),0);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_DL_FILENAME)),100);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_DL_SIZE)+"[^]"),1);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_DL_SIZE)),101);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_TYPE)+"[^]"),2);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_TYPE)),102);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_PRIORITY)+"[^]"),3);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_PRIORITY)),103);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_PERMISSION)+"[^]"),4);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_PERMISSION)),104);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_FILEID)+"[^]"),5);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_FILEID)),105);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_REQUESTS)+"[^]"),6);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_REQUESTS)),106);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_REQUESTS)+"[^^]"),10006);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_REQUESTS)+"[vv]"),10106);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_ACCEPTS)+"[^]"),7);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_ACCEPTS)),107);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_ACCEPTS)+"[^^]"),10007);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_ACCEPTS)+"[vv]"),10107);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_TRANSFERRED)+"[^]"),8);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_TRANSFERRED)),108);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_TRANSFERRED)+"[^^]"),10008);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_TRANSFERRED)+"[vv]"),10108);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_PARTTRAFFIC)+"[^]"),9);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_PARTTRAFFIC)),109);	//Cax2 bugfix 05/01/03
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_PARTTRAFFIC)+"[^^]"),10009);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_PARTTRAFFIC)+"[vv]"),10109);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_COLUPLOADS)+"[^]"),10);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_COLUPLOADS)),110);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_COLUPLOADS)+"[^^]"),10010);
		m_fileCols.SetItemData(m_fileCols.AddString(GetResString(IDS_SF_COLUPLOADS)+"[vv]"),10110);

		m_uploadCols.ResetContent();
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_QL_USERNAME)+"[^]"),0);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_QL_USERNAME)),10);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_FILE)+"[^]"),1);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_FILE)),11);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_DL_SPEED)+"[^]"),2);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_DL_SPEED)),12);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_DL_TRANSF)+"[^]"),3);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_DL_TRANSF)),13);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_WAITED)+"[^]"),4);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_WAITED)),14);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_UPLOADTIME)+"[^]"),5);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_UPLOADTIME)),15);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_STATUS)+"[^]"),6);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_STATUS)),16);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_COMPRESSION)+"[^]"),9);
		m_uploadCols.SetItemData(m_uploadCols.AddString(GetResString(IDS_COMPRESSION)),19);

		m_queueCols.ResetContent();
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_QL_USERNAME)+"[^]"),0);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_QL_USERNAME)),100);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_FILE)+"[^]"),1);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_FILE)),101);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_FILEPRIO)+"[^]"),2);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_FILEPRIO)),102);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_QL_RATING)+"[^]"),5);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_QL_RATING)),105);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_SCORE)+"[^]"),6);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_SCORE)),106);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_SFRATIO)+"[^]"),7);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_SFRATIO)),107);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_RFRATIO)+"[^]"),8);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_RFRATIO)),108);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_ASKED)+"[^]"),9);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_ASKED)),109);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_LASTSEEN)+"[^]"),10);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_LASTSEEN)),110);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_ENTERQUEUE)+"[^]"),11);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_ENTERQUEUE)),111);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_BANNED)+"[^]"),12);
		m_queueCols.SetItemData(m_queueCols.AddString(GetResString(IDS_BANNED)),112);

		m_searchCols.ResetContent();
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_DL_FILENAME)+"[^]"),0);
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_DL_FILENAME)),10);
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_DL_SIZE)+"[^]"),1);
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_DL_SIZE)),11);
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_DL_SOURCES)+"[^]"),2);
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_DL_SOURCES)),12);
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_TYPE)+"[^]"),3);
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_TYPE)),13);
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_FILEID)+"[^]"),4);
		m_searchCols.SetItemData(m_searchCols.AddString(GetResString(IDS_FILEID)),14);

		m_ircCols.ResetContent();
		m_ircCols.SetItemData(m_ircCols.AddString(GetResString(IDS_IRC_NAME)+"[^]"),0);
		m_ircCols.SetItemData(m_ircCols.AddString(GetResString(IDS_IRC_NAME)),10);
		m_ircCols.SetItemData(m_ircCols.AddString(GetResString(IDS_UUSERS)+"[^]"),1);
		m_ircCols.SetItemData(m_ircCols.AddString(GetResString(IDS_UUSERS)),11);
		m_ircCols.SetItemData(m_ircCols.AddString(GetResString(IDS_DESCRIPTION)+"[^]"),2);
		m_ircCols.SetItemData(m_ircCols.AddString(GetResString(IDS_DESCRIPTION)),12);

		m_downloadCols.ResetContent();
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_FILENAME)+"[^]"),0);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_FILENAME)),10);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_SIZE)+"[^]"),1);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_SIZE)),11);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_TRANSF)+"[^]"),2);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_TRANSF)),12);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_SPEED)+"[^]"),3);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_SPEED)),13);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_PROGRESS)+"[^]"),4);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_PROGRESS)),14);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_SOURCES)+"[^]"),5);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_SOURCES)),15);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_PRIORITY)+"[^]"),6);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_PRIORITY)),16);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_STATUS)+"[^]"),7);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_STATUS)),17);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_REMAINS)+"[^]"),8);
		m_downloadCols.SetItemData(m_downloadCols.AddString(GetResString(IDS_DL_REMAINS)),18);

		m_sourceCols1.ResetContent();
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_QL_USERNAME)+"[^]"),0);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_QL_USERNAME)),10);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_DL_TRANSF)+"[^]"),2);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_DL_TRANSF)),12);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_DL_SPEED)+"[^]"),3);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_DL_SPEED)),13);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_DL_PROGRESS)+"[^]"),4);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_DL_PROGRESS)),14);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString("QR[^]"),6);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString("QR"),16);
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_STATUS)+"[^]"),7);	//Cax2 changed for lord Kiron's
		m_sourceCols1.SetItemData(m_sourceCols1.AddString(GetResString(IDS_STATUS)),17);

		m_sourceCols2.ResetContent();
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_SORT_DEFAULT)),255);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_QL_USERNAME)+"[^]"),0);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_QL_USERNAME)),10);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_DL_TRANSF)+"[^]"),2);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_DL_TRANSF)),12);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_DL_SPEED)+"[^]"),3);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_DL_SPEED)),13);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_DL_PROGRESS)+"[^]"),4);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_DL_PROGRESS)),14);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString("QR[^]"),6);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString("QR"),16);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_STATUS)+"[^]"),7);
		m_sourceCols2.SetItemData(m_sourceCols2.AddString(GetResString(IDS_STATUS)),17);

		LoadSettings();
	}
	
}

void CPPgSorting::OnBnClickedSortSources2Box()
{
	GetDlgItem(IDC_SORT_SOURCES2)->EnableWindow(IsDlgButtonChecked(IDC_SORT_SOURCES2_BOX));

	SetModified();
}
