// PPgStats.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgStats.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgStats dialog

IMPLEMENT_DYNAMIC(CPPgStats, CPropertyPage)
CPPgStats::CPPgStats()
	: CPropertyPage(CPPgStats::IDD)
{
}

CPPgStats::~CPPgStats()
{
}

void CPPgStats::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPgStats)
	DDX_Control(pDX, IDC_COLOR_BUTTON, m_ctlColor);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COLORSELECTOR, m_colors);
	DDX_Control(pDX, IDC_RATIO, m_ratio);
}


BEGIN_MESSAGE_MAP(CPPgStats, CPropertyPage)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_ACSTAT, OnEnChangeACStats)
	ON_CBN_SELCHANGE(IDC_COLORSELECTOR, OnCbnSelchangeColorselector)
    ON_MESSAGE(CPN_SELCHANGE, OnSelChange)
	ON_BN_CLICKED(IDC_COLOR_BUTTON, OnBnClickedColorButton)
	ON_CBN_SELCHANGE(IDC_RATIO, OnCbnSelchangeRatio)
END_MESSAGE_MAP()


BOOL CPPgStats::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	for (int i=0;i<12;i++) {
		statcolors[i]=theApp.glob_prefs->GetStatsColor(i);
	}

	mystats1=app_prefs->GetTrafficOMeterInterval();
	mystats2=app_prefs->GetStatsInterval();
	mystats3=app_prefs->GetStatsAverageMinutes();

	((CSliderCtrl*)GetDlgItem(IDC_SLIDER))->SetRange(0,120,false);
	((CSliderCtrl*)GetDlgItem(IDC_SLIDER2))->SetRange(4,120,false);
	((CSliderCtrl*)GetDlgItem(IDC_SLIDER3))->SetRange(1,60,false);
	((CSliderCtrl*)GetDlgItem(IDC_SLIDER))->SetPos(mystats1); 
	((CSliderCtrl*)GetDlgItem(IDC_SLIDER2))->SetPos(mystats2);
	((CSliderCtrl*)GetDlgItem(IDC_SLIDER3))->SetPos(mystats3);

	CString strBuffer;
	strBuffer.Format("%d", app_prefs->GetStatsMax());
	GetDlgItem(IDC_ACSTAT)->SetWindowText(strBuffer);
	m_ratio.AddString("1:1");		// propstats Cax2
	m_ratio.AddString("1:2");
	m_ratio.AddString("1:3");
	m_ratio.AddString("1:4");
	m_ratio.AddString("1:5");
	m_ratio.AddString("1:10");
	int n=app_prefs->GetGraphRatio();
	m_ratio.SetCurSel((n==10)?5:n-1); // propstats Cax2

	m_ctlColor.TrackSelection	= TRUE;
	Localize();
	UpdateData(FALSE);
	SetModified(FALSE);

	return TRUE;
}

BOOL CPPgStats::OnApply()
{
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		char buffer[100];
		for (int i=0;i<12;i++) {
			theApp.glob_prefs->SetStatsColor(i,statcolors[i]);
		}
		theApp.glob_prefs->SetTrafficOMeterInterval(mystats1);
		theApp.glob_prefs->SetStatsInterval(mystats2);
		theApp.glob_prefs->SetStatsAverageMinutes(mystats3);
		int n=m_ratio.GetCurSel();
		app_prefs->SetGraphRatio((n==5)?10:n+1);	// propstats Cax2
		theApp.emuledlg->statisticswnd.Localize();
		theApp.emuledlg->statisticswnd.ShowInterval();
		
		GetDlgItem(IDC_ACSTAT)->GetWindowText(buffer,20);
		if(app_prefs->GetStatsMax() > app_prefs->GetMaxConnections())
		{
			app_prefs->SetStatsMax(app_prefs->GetMaxConnections());
			sprintf(buffer, "%d", app_prefs->GetStatsMax());
			GetDlgItem(IDC_ACSTAT)->SetWindowText(buffer);
		} else {
			app_prefs->SetStatsMax(atoi(buffer));
		}

		theApp.emuledlg->statisticswnd.UpdateActConScale();
		theApp.emuledlg->statisticswnd.RepaintMeters();

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgStats::Localize(void)
{
	if(m_hWnd)
	{
		GetDlgItem(IDC_GRAPHS)->SetWindowText(GetResString(IDS_GRAPHS));
		GetDlgItem(IDC_STREE)->SetWindowText(GetResString(IDS_STREE));
		GetDlgItem(IDC_ACSTAT_LBL)->SetWindowText(GetResString(IDS_ACSTAT_LBL));
		GetDlgItem(IDC_ACRATIO_LBL)->SetWindowText(GetResString(IDS_ACRATIO_LBL));
		SetWindowText(GetResString(IDS_STATSSETUPINFO));

		GetDlgItem(IDC_PREFCOLORS)->SetWindowText(GetResString(IDS_COLORS));

		m_colors.ResetContent();
		m_colors.AddString(GetResString(IDS_SP_BACKGROUND));
		m_colors.AddString(GetResString(IDS_SP_GRID));
		m_colors.AddString(GetResString(IDS_SP_DL1));
		m_colors.AddString(GetResString(IDS_SP_DL2));
		m_colors.AddString(GetResString(IDS_SP_DL3));
		m_colors.AddString(GetResString(IDS_SP_UL1));
		m_colors.AddString(GetResString(IDS_SP_UL2));
		m_colors.AddString(GetResString(IDS_SP_UL3));
		m_colors.AddString(GetResString(IDS_SP_ACTCON));
		m_colors.AddString(GetResString(IDS_SP_ACTUL));
		m_colors.AddString(GetResString(IDS_SP_ACTDL));
		m_colors.SetCurSel(0);
		ShowInterval();
		m_ctlColor.CustomText = _T(GetResString(IDS_COL_MORECOLORS));
		m_ctlColor.DefaultText = _T(GetResString(IDS_COL_AUTOMATIC));
		OnCbnSelchangeColorselector();
	}
}

void CPPgStats::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	
	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	int position = slider->GetPos();

	if (pScrollBar==GetDlgItem(IDC_SLIDER))
	{
		mystats1=position;
	} else if (pScrollBar==GetDlgItem(IDC_SLIDER2))	{
		mystats2=(position<5)?0:position;	// Cax2
	} else 
		mystats3=position;

	ShowInterval();

	UpdateData(false); 
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CPPgStats::ShowInterval() {
	CString m_SliderValue;
	
	if (mystats1==0) 
		m_SliderValue.Format(GetResString(IDS_DISABLED));
	else 
		m_SliderValue.Format(GetResString(IDS_STATS_UPDATELABEL), mystats1);
	GetDlgItem(IDC_SLIDERINFO)->SetWindowText(m_SliderValue);

	if (mystats2==0)
		m_SliderValue.Format(GetResString(IDS_DISABLED));
	else
		m_SliderValue.Format(GetResString(IDS_STATS_UPDATELABEL), mystats2);
	GetDlgItem(IDC_SLIDERINFO2)->SetWindowText(m_SliderValue);

	m_SliderValue.Format(GetResString(IDS_STATS_AVGLABEL), mystats3);
	GetDlgItem(IDC_SLIDERINFO3)->SetWindowText(m_SliderValue);
}

void CPPgStats::OnCbnSelchangeColorselector()
{
	m_ctlColor.SetColor((COLORREF) statcolors[m_colors.GetCurSel()]);
	m_ctlColor.SetDefaultColor(app_prefs->DefaultStatsColor(m_colors.GetCurSel()));
}

LONG CPPgStats::OnSelChange(UINT newColor, LONG /*wParam*/)
{
	statcolors[m_colors.GetCurSel()]=(COLORREF) newColor;
	SetModified(TRUE);
	return TRUE;
}

