#pragma once

#include "PPgGeneral.h"
#include "PPgConnection.h"
#include "PPgProxy.h"
#include "PPgServer.h"
#include "PPgAdvanced.h"
#include "PPgDirectories.h"
#include "PPgFiles.h"
#include "PPgIRC.h"
#include "PPgHTTPD.h" 	//Apfelteig patch
#include "PPgStats.h"
#include "PPgNotify.h"
#include "PPgModPT.h"
#include "PPgSorting.h" //SortDlg Cax2
#include "PPgWindow.h" 	// DonGato
#include "otherfunctions.h"
#include "ListBoxST.h"

// CPreferencesDlg

class CPreferencesDlg : public CPropertySheet
{
	DECLARE_DYNAMIC(CPreferencesDlg)

public:
	CPreferencesDlg();
	virtual ~CPreferencesDlg();
	afx_msg void OnApplyNow();
	afx_msg void OnOk();
	
protected:
	UINT m_nActiveWnd;
	DECLARE_MESSAGE_MAP()
public:
	CPPgGeneral		m_wndGeneral;
	CPPgConnection	m_wndConnection;
	CPPgProxy		m_wndProxy;      // Maverick
	CPPgServer		m_wndServer;
	CPPgAdvanced	m_wndAdvanced;
	CPPgDirectories	m_wndDirectories;
	CPPgFiles		m_wndFiles;
	CPPgIRC			m_wndIRC;
	CPPgHTTPD		m_wndHTTPD;  	// Apfelteig Patch
	CPPgStats		m_wndStats;
	CPPgNotify		m_wndNotify;
	CPPgModPT		m_wndModPT;
	CPPgSorting		m_wndSorting;  	// SortDlg Cax2
	CPPgWindow		m_wndWindow; 	// DonGato
	CPreferences	*app_prefs;
	CListBoxST 		m_listbox;
	CButton 		m_groupbox;
	CImageList 		ImageList;

	void SetPrefs(CPreferences* in_prefs)
	{
		app_prefs = in_prefs;
		m_wndGeneral.SetPrefs(in_prefs);
		m_wndConnection.SetPrefs(in_prefs);
		m_wndProxy.SetPrefs(in_prefs);     // Maverick
		m_wndServer.SetPrefs(in_prefs);
		m_wndAdvanced.SetPrefs(in_prefs);
		m_wndDirectories.SetPrefs(in_prefs);
		m_wndFiles.SetPrefs(in_prefs);
		m_wndIRC.SetPrefs(in_prefs);
		m_wndHTTPD.SetPrefs(in_prefs);		// LENN HT
		m_wndStats.SetPrefs(in_prefs);
		m_wndNotify.SetPrefs(in_prefs);
		m_wndModPT.SetPrefs(in_prefs);
		m_wndSorting.SetPrefs(in_prefs);  	// SortDlg Cax2
		m_wndWindow.SetPrefs(in_prefs);		// DonGato
	}
	afx_msg void OnDestroy();
	afx_msg void OnSelChanged();
	virtual BOOL OnInitDialog();
	void Localize();
};
