#include "stdafx.h"

#include "StatusBarCtrl.h"
#include "opcodes.h"
#include "emule.h"



BEGIN_MESSAGE_MAP(StatusBarCtrl, CStatusBarCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()



//-------------------------------------------------------------------------------------------------
StatusBarCtrl::~StatusBarCtrl()
{
	//--- free the menu memory ---
	m_popupMenuUp.DestroyMenu();
	m_popupMenuDown.DestroyMenu();
}



//-------------------------------------------------------------------------------------------------
void StatusBarCtrl::OnLButtonDown(UINT nFlags, CPoint point)
{
	//--- get the rect where the speed is displayed ---
	CRect rect;
	GetRect(2, rect);

	//--- is point in this rect ---
	if(rect.PtInRect(point)==false)
		return;

	//--- destroy and create the menu ---
	m_popupMenuUp.DestroyMenu();
	m_popupMenuUp.CreatePopupMenu();

	//--- title ---
	m_popupMenuUp.AddMenuTitle("Upload Speed");

	CString text;

	//--- speed settings overview ---
	text.Format("%s:\t%i KB/s", GetResString(IDS_PW_UPC), theApp.glob_prefs->GetMaxGraphUploadRate());	
	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_UPC, text);
	m_popupMenuUp.EnableMenuItem(MP_QS_UPC, MF_DISABLED);

	if(theApp.glob_prefs->GetMaxUpload()==UNLIMITED)
		text.Format("%s:\tunlimited", GetResString(IDS_PW_UPL), theApp.glob_prefs->GetMaxUpload());
	else
		text.Format("%s:\t%i KB/s", GetResString(IDS_PW_UPL), theApp.glob_prefs->GetMaxUpload());	
	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_UPL,  text);
	m_popupMenuUp.EnableMenuItem(MP_QS_UPL, MF_DISABLED);

	m_popupMenuUp.AppendMenu(MF_SEPARATOR);

	//--- 10..20..30.....100% ---
	text.Format("&10%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.1));	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U10,  text);
	text.Format("&20%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.2));	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U20,  text);
	text.Format("&30%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.3));	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U30,  text);
	text.Format("&40%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.4));	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U40,  text);
	text.Format("&50%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.5));	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U50,  text);
	text.Format("&60%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.6));	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U60,  text);
	text.Format("&70%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.7));	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U70,  text);
	text.Format("&80%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.8));	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U80,  text);
	text.Format("&90%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.9));	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U90,  text);
	text.Format("1&00%%\t%i KB/s", (uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()));		m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_U100, text);
	m_popupMenuUp.AppendMenu(MF_STRING, MP_QS_UPC, "unlimited");

	//--- get mouse pos ---
	POINT cp;
	GetCursorPos(&cp);
	m_popupMenuUp.TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, cp.x, cp.y, theApp.emuledlg);
}



//-------------------------------------------------------------------------------------------------
void StatusBarCtrl::OnRButtonDown(UINT nFlags, CPoint point)
{
	//--- get the rect where the speed is displayed ---
	CRect rect;
	GetRect(2, rect);

	//--- is point in this rect ---
	if(rect.PtInRect(point)==false)
		return;

	//--- destroy and create the menu ---
	m_popupMenuDown.DestroyMenu();
	m_popupMenuDown.CreatePopupMenu();

	//--- title ---
	m_popupMenuDown.AddMenuTitle("Download Speed");

	CString text;

	//--- speed settings overview ---
	text.Format("%s:\t%i KB/s", GetResString(IDS_PW_DOWNC), theApp.glob_prefs->GetMaxGraphDownloadRate());	
	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_DC,  text);
	m_popupMenuDown.EnableMenuItem(MP_QS_DC, MF_DISABLED);

	if(theApp.glob_prefs->GetMaxDownload()==UNLIMITED)
		text.Format("%s:\tunlimited", GetResString(IDS_PW_DOWNL), theApp.glob_prefs->GetMaxDownload());
	else
		text.Format("%s:\t%i KB/s", GetResString(IDS_PW_DOWNL), theApp.glob_prefs->GetMaxDownload());	
	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_DL,  text);
	m_popupMenuDown.EnableMenuItem(MP_QS_DL, MF_DISABLED);

	m_popupMenuDown.AppendMenu(MF_SEPARATOR);

	//--- 10..20..30.....100% ---
	text.Format("&10%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.1));	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D10,  text);
	text.Format("&20%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.2));	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D20,  text);
	text.Format("&30%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.3));	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D30,  text);
	text.Format("&40%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.4));	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D40,  text);
	text.Format("&50%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.5));	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D50,  text);
	text.Format("&60%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.6));	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D60,  text);
	text.Format("&70%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.7));	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D70,  text);
	text.Format("&80%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.8));	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D80,  text);
	text.Format("&90%%\t%i KB/s",  (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.9));	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D90,  text);
	text.Format("1&00%%\t%i KB/s", (uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()));		m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_D100, text);
	m_popupMenuDown.AppendMenu(MF_STRING, MP_QS_DC, "unlimited");

	//--- get mouse pos ---
	POINT cp;
	GetCursorPos(&cp);
	m_popupMenuDown.TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, cp.x, cp.y, theApp.emuledlg);
}
